from __future__ import annotations
from collections.abc import Callable
from dataclasses import dataclass, field
from kiota_abstractions.serialization import Parsable, ParseNode, SerializationWriter
from typing import Any, Optional, TYPE_CHECKING, Union

if TYPE_CHECKING:
    from .admin_windows_updates import AdminWindowsUpdates
    from .entity import Entity

from .entity import Entity

@dataclass
class AdminWindows(Entity, Parsable):
    # The OdataType property
    odata_type: Optional[str] = None
    # Entity that acts as a container for all Windows Update for Business deployment service functionalities. Read-only.
    updates: Optional[AdminWindowsUpdates] = None
    
    @staticmethod
    def create_from_discriminator_value(parse_node: ParseNode) -> AdminWindows:
        """
        Creates a new instance of the appropriate class based on discriminator value
        param parse_node: The parse node to use to read the discriminator value and create the object
        Returns: AdminWindows
        """
        if parse_node is None:
            raise TypeError("parse_node cannot be null.")
        return AdminWindows()
    
    def get_field_deserializers(self,) -> dict[str, Callable[[ParseNode], None]]:
        """
        The deserialization information for the current model
        Returns: dict[str, Callable[[ParseNode], None]]
        """
        from .admin_windows_updates import AdminWindowsUpdates
        from .entity import Entity

        from .admin_windows_updates import AdminWindowsUpdates
        from .entity import Entity

        fields: dict[str, Callable[[Any], None]] = {
            "updates": lambda n : setattr(self, 'updates', n.get_object_value(AdminWindowsUpdates)),
        }
        super_fields = super().get_field_deserializers()
        fields.update(super_fields)
        return fields
    
    def serialize(self,writer: SerializationWriter) -> None:
        """
        Serializes information the current object
        param writer: Serialization writer to use to serialize this model
        Returns: None
        """
        if writer is None:
            raise TypeError("writer cannot be null.")
        super().serialize(writer)
        writer.write_object_value("updates", self.updates)
    

