from __future__ import annotations
from collections.abc import Callable
from dataclasses import dataclass, field
from kiota_abstractions.serialization import Parsable, ParseNode, SerializationWriter
from typing import Any, Optional, TYPE_CHECKING, Union

if TYPE_CHECKING:
    from .entity import Entity

from .entity import Entity

@dataclass
class ExchangeSettings(Entity, Parsable):
    # The unique identifier for the user's in-place archive mailbox.
    in_place_archive_mailbox_id: Optional[str] = None
    # The OdataType property
    odata_type: Optional[str] = None
    # The unique identifier for the user's primary mailbox.
    primary_mailbox_id: Optional[str] = None
    
    @staticmethod
    def create_from_discriminator_value(parse_node: ParseNode) -> ExchangeSettings:
        """
        Creates a new instance of the appropriate class based on discriminator value
        param parse_node: The parse node to use to read the discriminator value and create the object
        Returns: ExchangeSettings
        """
        if parse_node is None:
            raise TypeError("parse_node cannot be null.")
        return ExchangeSettings()
    
    def get_field_deserializers(self,) -> dict[str, Callable[[ParseNode], None]]:
        """
        The deserialization information for the current model
        Returns: dict[str, Callable[[ParseNode], None]]
        """
        from .entity import Entity

        from .entity import Entity

        fields: dict[str, Callable[[Any], None]] = {
            "inPlaceArchiveMailboxId": lambda n : setattr(self, 'in_place_archive_mailbox_id', n.get_str_value()),
            "primaryMailboxId": lambda n : setattr(self, 'primary_mailbox_id', n.get_str_value()),
        }
        super_fields = super().get_field_deserializers()
        fields.update(super_fields)
        return fields
    
    def serialize(self,writer: SerializationWriter) -> None:
        """
        Serializes information the current object
        param writer: Serialization writer to use to serialize this model
        Returns: None
        """
        if writer is None:
            raise TypeError("writer cannot be null.")
        super().serialize(writer)
        writer.write_str_value("inPlaceArchiveMailboxId", self.in_place_archive_mailbox_id)
        writer.write_str_value("primaryMailboxId", self.primary_mailbox_id)
    

