from enum import Enum

class AuditLogRecordType(str, Enum):
    ExchangeAdmin = "ExchangeAdmin",
    ExchangeItem = "ExchangeItem",
    ExchangeItemGroup = "ExchangeItemGroup",
    SharePoint = "SharePoint",
    SyntheticProbe = "SyntheticProbe",
    SharePointFileOperation = "SharePointFileOperation",
    OneDrive = "OneDrive",
    AzureActiveDirectory = "AzureActiveDirectory",
    AzureActiveDirectoryAccountLogon = "AzureActiveDirectoryAccountLogon",
    DataCenterSecurityCmdlet = "DataCenterSecurityCmdlet",
    ComplianceDLPSharePoint = "ComplianceDLPSharePoint",
    Sway = "Sway",
    ComplianceDLPExchange = "ComplianceDLPExchange",
    SharePointSharingOperation = "SharePointSharingOperation",
    AzureActiveDirectoryStsLogon = "AzureActiveDirectoryStsLogon",
    SkypeForBusinessPSTNUsage = "SkypeForBusinessPSTNUsage",
    SkypeForBusinessUsersBlocked = "SkypeForBusinessUsersBlocked",
    SecurityComplianceCenterEOPCmdlet = "SecurityComplianceCenterEOPCmdlet",
    ExchangeAggregatedOperation = "ExchangeAggregatedOperation",
    PowerBIAudit = "PowerBIAudit",
    CRM = "CRM",
    Yammer = "Yammer",
    SkypeForBusinessCmdlets = "SkypeForBusinessCmdlets",
    Discovery = "Discovery",
    MicrosoftTeams = "MicrosoftTeams",
    ThreatIntelligence = "ThreatIntelligence",
    MailSubmission = "MailSubmission",
    MicrosoftFlow = "MicrosoftFlow",
    AeD = "AeD",
    MicrosoftStream = "MicrosoftStream",
    ComplianceDLPSharePointClassification = "ComplianceDLPSharePointClassification",
    ThreatFinder = "ThreatFinder",
    Project = "Project",
    SharePointListOperation = "SharePointListOperation",
    SharePointCommentOperation = "SharePointCommentOperation",
    DataGovernance = "DataGovernance",
    Kaizala = "Kaizala",
    SecurityComplianceAlerts = "SecurityComplianceAlerts",
    ThreatIntelligenceUrl = "ThreatIntelligenceUrl",
    SecurityComplianceInsights = "SecurityComplianceInsights",
    MIPLabel = "MIPLabel",
    WorkplaceAnalytics = "WorkplaceAnalytics",
    PowerAppsApp = "PowerAppsApp",
    PowerAppsPlan = "PowerAppsPlan",
    ThreatIntelligenceAtpContent = "ThreatIntelligenceAtpContent",
    LabelContentExplorer = "LabelContentExplorer",
    TeamsHealthcare = "TeamsHealthcare",
    ExchangeItemAggregated = "ExchangeItemAggregated",
    HygieneEvent = "HygieneEvent",
    DataInsightsRestApiAudit = "DataInsightsRestApiAudit",
    InformationBarrierPolicyApplication = "InformationBarrierPolicyApplication",
    SharePointListItemOperation = "SharePointListItemOperation",
    SharePointContentTypeOperation = "SharePointContentTypeOperation",
    SharePointFieldOperation = "SharePointFieldOperation",
    MicrosoftTeamsAdmin = "MicrosoftTeamsAdmin",
    HRSignal = "HRSignal",
    MicrosoftTeamsDevice = "MicrosoftTeamsDevice",
    MicrosoftTeamsAnalytics = "MicrosoftTeamsAnalytics",
    InformationWorkerProtection = "InformationWorkerProtection",
    Campaign = "Campaign",
    DLPEndpoint = "DLPEndpoint",
    AirInvestigation = "AirInvestigation",
    Quarantine = "Quarantine",
    MicrosoftForms = "MicrosoftForms",
    ApplicationAudit = "ApplicationAudit",
    ComplianceSupervisionExchange = "ComplianceSupervisionExchange",
    CustomerKeyServiceEncryption = "CustomerKeyServiceEncryption",
    OfficeNative = "OfficeNative",
    MipAutoLabelSharePointItem = "MipAutoLabelSharePointItem",
    MipAutoLabelSharePointPolicyLocation = "MipAutoLabelSharePointPolicyLocation",
    MicrosoftTeamsShifts = "MicrosoftTeamsShifts",
    SecureScore = "SecureScore",
    MipAutoLabelExchangeItem = "MipAutoLabelExchangeItem",
    CortanaBriefing = "CortanaBriefing",
    Search = "Search",
    WDATPAlerts = "WDATPAlerts",
    PowerPlatformAdminDlp = "PowerPlatformAdminDlp",
    PowerPlatformAdminEnvironment = "PowerPlatformAdminEnvironment",
    MDATPAudit = "MDATPAudit",
    SensitivityLabelPolicyMatch = "SensitivityLabelPolicyMatch",
    SensitivityLabelAction = "SensitivityLabelAction",
    SensitivityLabeledFileAction = "SensitivityLabeledFileAction",
    AttackSim = "AttackSim",
    AirManualInvestigation = "AirManualInvestigation",
    SecurityComplianceRBAC = "SecurityComplianceRBAC",
    UserTraining = "UserTraining",
    AirAdminActionInvestigation = "AirAdminActionInvestigation",
    MSTIC = "MSTIC",
    PhysicalBadgingSignal = "PhysicalBadgingSignal",
    TeamsEasyApprovals = "TeamsEasyApprovals",
    AipDiscover = "AipDiscover",
    AipSensitivityLabelAction = "AipSensitivityLabelAction",
    AipProtectionAction = "AipProtectionAction",
    AipFileDeleted = "AipFileDeleted",
    AipHeartBeat = "AipHeartBeat",
    MCASAlerts = "MCASAlerts",
    OnPremisesFileShareScannerDlp = "OnPremisesFileShareScannerDlp",
    OnPremisesSharePointScannerDlp = "OnPremisesSharePointScannerDlp",
    ExchangeSearch = "ExchangeSearch",
    SharePointSearch = "SharePointSearch",
    PrivacyDataMinimization = "PrivacyDataMinimization",
    LabelAnalyticsAggregate = "LabelAnalyticsAggregate",
    MyAnalyticsSettings = "MyAnalyticsSettings",
    SecurityComplianceUserChange = "SecurityComplianceUserChange",
    ComplianceDLPExchangeClassification = "ComplianceDLPExchangeClassification",
    ComplianceDLPEndpoint = "ComplianceDLPEndpoint",
    MipExactDataMatch = "MipExactDataMatch",
    MSDEResponseActions = "MSDEResponseActions",
    MSDEGeneralSettings = "MSDEGeneralSettings",
    MSDEIndicatorsSettings = "MSDEIndicatorsSettings",
    MS365DCustomDetection = "MS365DCustomDetection",
    MSDERolesSettings = "MSDERolesSettings",
    MAPGAlerts = "MAPGAlerts",
    MAPGPolicy = "MAPGPolicy",
    MAPGRemediation = "MAPGRemediation",
    PrivacyRemediationAction = "PrivacyRemediationAction",
    PrivacyDigestEmail = "PrivacyDigestEmail",
    MipAutoLabelSimulationProgress = "MipAutoLabelSimulationProgress",
    MipAutoLabelSimulationCompletion = "MipAutoLabelSimulationCompletion",
    MipAutoLabelProgressFeedback = "MipAutoLabelProgressFeedback",
    DlpSensitiveInformationType = "DlpSensitiveInformationType",
    MipAutoLabelSimulationStatistics = "MipAutoLabelSimulationStatistics",
    LargeContentMetadata = "LargeContentMetadata",
    Microsoft365Group = "Microsoft365Group",
    CDPMlInferencingResult = "CDPMlInferencingResult",
    FilteringMailMetadata = "FilteringMailMetadata",
    CDPClassificationMailItem = "CDPClassificationMailItem",
    CDPClassificationDocument = "CDPClassificationDocument",
    OfficeScriptsRunAction = "OfficeScriptsRunAction",
    FilteringPostMailDeliveryAction = "FilteringPostMailDeliveryAction",
    CDPUnifiedFeedback = "CDPUnifiedFeedback",
    TenantAllowBlockList = "TenantAllowBlockList",
    ConsumptionResource = "ConsumptionResource",
    HealthcareSignal = "HealthcareSignal",
    DlpImportResult = "DlpImportResult",
    CDPCompliancePolicyExecution = "CDPCompliancePolicyExecution",
    MultiStageDisposition = "MultiStageDisposition",
    PrivacyDataMatch = "PrivacyDataMatch",
    FilteringDocMetadata = "FilteringDocMetadata",
    FilteringEmailFeatures = "FilteringEmailFeatures",
    PowerBIDlp = "PowerBIDlp",
    FilteringUrlInfo = "FilteringUrlInfo",
    FilteringAttachmentInfo = "FilteringAttachmentInfo",
    CoreReportingSettings = "CoreReportingSettings",
    ComplianceConnector = "ComplianceConnector",
    PowerPlatformLockboxResourceAccessRequest = "PowerPlatformLockboxResourceAccessRequest",
    PowerPlatformLockboxResourceCommand = "PowerPlatformLockboxResourceCommand",
    CDPPredictiveCodingLabel = "CDPPredictiveCodingLabel",
    CDPCompliancePolicyUserFeedback = "CDPCompliancePolicyUserFeedback",
    WebpageActivityEndpoint = "WebpageActivityEndpoint",
    OMEPortal = "OMEPortal",
    CMImprovementActionChange = "CMImprovementActionChange",
    FilteringUrlClick = "FilteringUrlClick",
    MipLabelAnalyticsAuditRecord = "MipLabelAnalyticsAuditRecord",
    FilteringEntityEvent = "FilteringEntityEvent",
    FilteringRuleHits = "FilteringRuleHits",
    FilteringMailSubmission = "FilteringMailSubmission",
    LabelExplorer = "LabelExplorer",
    MicrosoftManagedServicePlatform = "MicrosoftManagedServicePlatform",
    PowerPlatformServiceActivity = "PowerPlatformServiceActivity",
    ScorePlatformGenericAuditRecord = "ScorePlatformGenericAuditRecord",
    FilteringTimeTravelDocMetadata = "FilteringTimeTravelDocMetadata",
    Alert = "Alert",
    AlertStatus = "AlertStatus",
    AlertIncident = "AlertIncident",
    IncidentStatus = "IncidentStatus",
    Case = "Case",
    CaseInvestigation = "CaseInvestigation",
    RecordsManagement = "RecordsManagement",
    PrivacyRemediation = "PrivacyRemediation",
    DataShareOperation = "DataShareOperation",
    CdpDlpSensitive = "CdpDlpSensitive",
    EHRConnector = "EHRConnector",
    FilteringMailGradingResult = "FilteringMailGradingResult",
    PublicFolder = "PublicFolder",
    PrivacyTenantAuditHistoryRecord = "PrivacyTenantAuditHistoryRecord",
    AipScannerDiscoverEvent = "AipScannerDiscoverEvent",
    EduDataLakeDownloadOperation = "EduDataLakeDownloadOperation",
    M365ComplianceConnector = "M365ComplianceConnector",
    MicrosoftGraphDataConnectOperation = "MicrosoftGraphDataConnectOperation",
    MicrosoftPurview = "MicrosoftPurview",
    FilteringEmailContentFeatures = "FilteringEmailContentFeatures",
    PowerPagesSite = "PowerPagesSite",
    PowerAppsResource = "PowerAppsResource",
    PlannerPlan = "PlannerPlan",
    PlannerCopyPlan = "PlannerCopyPlan",
    PlannerTask = "PlannerTask",
    PlannerRoster = "PlannerRoster",
    PlannerPlanList = "PlannerPlanList",
    PlannerTaskList = "PlannerTaskList",
    PlannerTenantSettings = "PlannerTenantSettings",
    ProjectForTheWebProject = "ProjectForTheWebProject",
    ProjectForTheWebTask = "ProjectForTheWebTask",
    ProjectForTheWebRoadmap = "ProjectForTheWebRoadmap",
    ProjectForTheWebRoadmapItem = "ProjectForTheWebRoadmapItem",
    ProjectForTheWebProjectSettings = "ProjectForTheWebProjectSettings",
    ProjectForTheWebRoadmapSettings = "ProjectForTheWebRoadmapSettings",
    QuarantineMetadata = "QuarantineMetadata",
    MicrosoftTodoAudit = "MicrosoftTodoAudit",
    TimeTravelFilteringDocMetadata = "TimeTravelFilteringDocMetadata",
    TeamsQuarantineMetadata = "TeamsQuarantineMetadata",
    SharePointAppPermissionOperation = "SharePointAppPermissionOperation",
    MicrosoftTeamsSensitivityLabelAction = "MicrosoftTeamsSensitivityLabelAction",
    FilteringTeamsMetadata = "FilteringTeamsMetadata",
    FilteringTeamsUrlInfo = "FilteringTeamsUrlInfo",
    FilteringTeamsPostDeliveryAction = "FilteringTeamsPostDeliveryAction",
    MDCAssessments = "MDCAssessments",
    MDCRegulatoryComplianceStandards = "MDCRegulatoryComplianceStandards",
    MDCRegulatoryComplianceControls = "MDCRegulatoryComplianceControls",
    MDCRegulatoryComplianceAssessments = "MDCRegulatoryComplianceAssessments",
    MDCSecurityConnectors = "MDCSecurityConnectors",
    MDADataSecuritySignal = "MDADataSecuritySignal",
    VivaGoals = "VivaGoals",
    FilteringRuntimeInfo = "FilteringRuntimeInfo",
    AttackSimAdmin = "AttackSimAdmin",
    MicrosoftGraphDataConnectConsent = "MicrosoftGraphDataConnectConsent",
    FilteringAtpDetonationInfo = "FilteringAtpDetonationInfo",
    PrivacyPortal = "PrivacyPortal",
    ManagedTenants = "ManagedTenants",
    UnifiedSimulationMatchedItem = "UnifiedSimulationMatchedItem",
    UnifiedSimulationSummary = "UnifiedSimulationSummary",
    UpdateQuarantineMetadata = "UpdateQuarantineMetadata",
    MS365DSuppressionRule = "MS365DSuppressionRule",
    PurviewDataMapOperation = "PurviewDataMapOperation",
    FilteringUrlPostClickAction = "FilteringUrlPostClickAction",
    IrmUserDefinedDetectionSignal = "IrmUserDefinedDetectionSignal",
    TeamsUpdates = "TeamsUpdates",
    PlannerRosterSensitivityLabel = "PlannerRosterSensitivityLabel",
    MS365DIncident = "MS365DIncident",
    FilteringDelistingMetadata = "FilteringDelistingMetadata",
    ComplianceDLPSharePointClassificationExtended = "ComplianceDLPSharePointClassificationExtended",
    MicrosoftDefenderForIdentityAudit = "MicrosoftDefenderForIdentityAudit",
    SupervisoryReviewDayXInsight = "SupervisoryReviewDayXInsight",
    DefenderExpertsforXDRAdmin = "DefenderExpertsforXDRAdmin",
    CDPEdgeBlockedMessage = "CDPEdgeBlockedMessage",
    HostedRpa = "HostedRpa",
    CdpContentExplorerAggregateRecord = "CdpContentExplorerAggregateRecord",
    CDPHygieneAttachmentInfo = "CDPHygieneAttachmentInfo",
    CDPHygieneSummary = "CDPHygieneSummary",
    CDPPostMailDeliveryAction = "CDPPostMailDeliveryAction",
    CDPEmailFeatures = "CDPEmailFeatures",
    CDPHygieneUrlInfo = "CDPHygieneUrlInfo",
    CDPUrlClick = "CDPUrlClick",
    CDPPackageManagerHygieneEvent = "CDPPackageManagerHygieneEvent",
    FilteringDocScan = "FilteringDocScan",
    TimeTravelFilteringDocScan = "TimeTravelFilteringDocScan",
    MAPGOnboard = "MAPGOnboard",
    VfamCreatePolicy = "VfamCreatePolicy",
    VfamUpdatePolicy = "VfamUpdatePolicy",
    VfamDeletePolicy = "VfamDeletePolicy",
    M365DAAD = "M365DAAD",
    CdpColdCrawlStatus = "CdpColdCrawlStatus",
    PowerPlatformAdministratorActivity = "PowerPlatformAdministratorActivity",
    Windows365CustomerLockbox = "Windows365CustomerLockbox",
    CdpResourceScopeChangeEvent = "CdpResourceScopeChangeEvent",
    ComplianceCCExchangeExecutionResult = "ComplianceCCExchangeExecutionResult",
    CdpOcrCostEstimatorRecord = "CdpOcrCostEstimatorRecord",
    CopilotInteraction = "CopilotInteraction",
    CdpOcrBillingRecord = "CdpOcrBillingRecord",
    ComplianceDLPApplications = "ComplianceDLPApplications",
    UAMOperation = "UAMOperation",
    VivaLearning = "VivaLearning",
    VivaLearningAdmin = "VivaLearningAdmin",
    PurviewPolicyOperation = "PurviewPolicyOperation",
    PurviewMetadataPolicyOperation = "PurviewMetadataPolicyOperation",
    PeopleAdminSettings = "PeopleAdminSettings",
    CdpComplianceDLPExchangeClassification = "CdpComplianceDLPExchangeClassification",
    CdpComplianceDLPSharePointClassification = "CdpComplianceDLPSharePointClassification",
    FilteringBulkSenderInsightData = "FilteringBulkSenderInsightData",
    FilteringBulkThresholdInsightData = "FilteringBulkThresholdInsightData",
    PrivacyOpenAccess = "PrivacyOpenAccess",
    OWAAuth = "OWAAuth",
    ComplianceDLPApplicationsClassification = "ComplianceDLPApplicationsClassification",
    SharePointESignature = "SharePointESignature",
    Dynamics365BusinessCentral = "Dynamics365BusinessCentral",
    MeshWorlds = "MeshWorlds",
    VivaPulseResponse = "VivaPulseResponse",
    VivaPulseOrganizer = "VivaPulseOrganizer",
    VivaPulseAdmin = "VivaPulseAdmin",
    VivaPulseReport = "VivaPulseReport",
    AIAppInteraction = "AIAppInteraction",
    ComplianceDLMExchange = "ComplianceDLMExchange",
    ComplianceDLMSharePoint = "ComplianceDLMSharePoint",
    ProjectForTheWebAssignedToMeSettings = "ProjectForTheWebAssignedToMeSettings",
    CPSOperation = "CPSOperation",
    ComplianceDLPExchangeDiscovery = "ComplianceDLPExchangeDiscovery",
    PurviewMCRecommendation = "PurviewMCRecommendation",
    UnknownFutureValue = "unknownFutureValue",

